diff --git a/web/pgadmin/browser/static/js/browser.js b/web/pgadmin/browser/static/js/browser.js
index 4aa5b8ba..3dac0cb6 100644
--- a/web/pgadmin/browser/static/js/browser.js
+++ b/web/pgadmin/browser/static/js/browser.js
@@ -1,17 +1,16 @@
-define(
-  'pgadmin.browser', [
-    'sources/gettext', 'sources/url_for', 'require', 'jquery', 'underscore', 'underscore.string',
-    'bootstrap', 'sources/pgadmin', 'pgadmin.alertifyjs', 'bundled_codemirror',
-    'sources/check_node_visibility', 'pgadmin.browser.utils', 'wcdocker',
-    'jquery.contextmenu', 'jquery.aciplugin', 'jquery.acitree',
-    'pgadmin.browser.messages',
-    'pgadmin.browser.menu', 'pgadmin.browser.panel',
-    'pgadmin.browser.error', 'pgadmin.browser.frame',
-    'pgadmin.browser.node', 'pgadmin.browser.collection',
-    'sources/codemirror/addon/fold/pgadmin-sqlfoldcode'
-  ], function(
-    gettext, url_for, require, $, _, S, Bootstrap, pgAdmin, Alertify,
-    codemirror, checkNodeVisibility
+define('pgadmin.browser', [
+  'sources/gettext', 'sources/url_for', 'require', 'jquery', 'underscore', 'underscore.string',
+  'bootstrap', 'sources/pgadmin', 'pgadmin.alertifyjs', 'bundled_codemirror',
+  'sources/check_node_visibility', 'pgadmin.browser.utils', 'wcdocker',
+  'jquery.contextmenu', 'jquery.aciplugin', 'jquery.acitree',
+  'pgadmin.browser.messages',
+  'pgadmin.browser.menu', 'pgadmin.browser.panel',
+  'pgadmin.browser.error', 'pgadmin.browser.frame',
+  'pgadmin.browser.node', 'pgadmin.browser.collection',
+  'sources/codemirror/addon/fold/pgadmin-sqlfoldcode',
+], function(
+  gettext, url_for, require, $, _, S, Bootstrap, pgAdmin, Alertify,
+  codemirror, checkNodeVisibility
 ) {
   window.jQuery = window.$ = $;
   // Some scripts do export their object in the window only.
@@ -28,11 +27,11 @@ define(
   panelEvents[wcDocker.EVENT.VISIBILITY_CHANGED] = function() {
     if (this.isVisible()) {
       var obj = pgAdmin.Browser,
-          i   = obj.tree ? obj.tree.selected() : undefined,
-          d   = i && i.length == 1 ? obj.tree.itemData(i) : undefined;
+        i   = obj.tree ? obj.tree.selected() : undefined,
+        d   = i && i.length == 1 ? obj.tree.itemData(i) : undefined;
 
       if (d && obj.Nodes[d._type].callbacks['selected'] &&
-          _.isFunction(obj.Nodes[d._type].callbacks['selected'])) {
+        _.isFunction(obj.Nodes[d._type].callbacks['selected'])) {
         return obj.Nodes[d._type].callbacks['selected'].apply(
             obj.Nodes[d._type], [i, d, obj]);
       }
@@ -42,15 +41,15 @@ define(
   var processTreeData = function(payload) {
     var data = JSON.parse(payload).data;
     if (data.length && data[0]._type !== 'column' &&
-        data[0]._type !== 'catalog_object_column') {
+      data[0]._type !== 'catalog_object_column') {
       data = data.sort(function(a, b) {
-          return pgAdmin.natural_sort(a.label, b.label);
+        return pgAdmin.natural_sort(a.label, b.label);
       });
     }
     _.each(data, function(d){
       d._label = d.label;
       d.label = _.escape(d.label);
-    })
+    });
     return data;
   };
 
@@ -61,7 +60,7 @@ define(
           url: url_for('browser.nodes'),
           converters: {
             'text json': processTreeData,
-          }
+          },
         },
         ajaxHook: function(item, settings) {
           if (item != null) {
@@ -73,14 +72,14 @@ define(
         },
         loaderDelay: 100,
         show: {
-          duration: 75
+          duration: 75,
         },
         hide: {
-          duration: 75
+          duration: 75,
         },
         view: {
-          duration: 75
-        }
+          duration: 75,
+        },
       });
 
       b.tree = $('#tree').aciTree('api');
@@ -112,7 +111,7 @@ define(
         isCloseable: false,
         isPrivate: true,
         icon: 'fa fa-binoculars',
-        content: '<div id="tree" class="aciTree"></div>'
+        content: '<div id="tree" class="aciTree"></div>',
       }),
       // Properties of the object node
       'properties': new pgAdmin.Browser.Panel({
@@ -127,7 +126,7 @@ define(
         events: panelEvents,
         onCreate: function(myPanel, $container) {
           $container.addClass('pg-no-overflow');
-        }
+        },
       }),
       // Statistics of the object
       'statistics': new pgAdmin.Browser.Panel({
@@ -138,7 +137,7 @@ define(
         isCloseable: false,
         isPrivate: true,
         content: '<div><div class="alert alert-info pg-panel-message pg-panel-statistics-message">' + select_object_msg + '</div><div class="pg-panel-statistics-container hidden"></div></div>',
-        events: panelEvents
+        events: panelEvents,
       }),
       // Reversed engineered SQL for the object
       'sql': new pgAdmin.Browser.Panel({
@@ -148,7 +147,7 @@ define(
         width: 500,
         isCloseable: false,
         isPrivate: true,
-        content: '<div class="sql_textarea"><textarea id="sql-textarea" name="sql-textarea"></textarea></div>'
+        content: '<div class="sql_textarea"><textarea id="sql-textarea" name="sql-textarea"></textarea></div>',
       }),
       // Dependencies of the object
       'dependencies': new pgAdmin.Browser.Panel({
@@ -159,7 +158,7 @@ define(
         isCloseable: false,
         isPrivate: true,
         content: '<div><div class="alert alert-info pg-panel-message pg-panel-depends-message">' + select_object_msg + '</div><div class="pg-panel-depends-container hidden"></div></div>',
-        events: panelEvents
+        events: panelEvents,
       }),
       // Dependents of the object
       'dependents': new pgAdmin.Browser.Panel({
@@ -170,14 +169,14 @@ define(
         isCloseable: false,
         isPrivate: true,
         content: '<div><div class="alert alert-info pg-panel-message pg-panel-depends-message">' + select_object_msg + '</div><div class="pg-panel-depends-container hidden"></div></div>',
-        events: panelEvents
-      })
+        events: panelEvents,
+      }),
     },
     // We also support showing dashboards, HTML file, external URL
     frames: {},
-      /* Menus */
-      // pgAdmin.Browser.MenuItem.add_menus(...) will register all the menus
-      // in this container
+    /* Menus */
+    // pgAdmin.Browser.MenuItem.add_menus(...) will register all the menus
+    // in this container
     menus: {
       // All context menu goes here under certain menu types.
       // i.e. context: {'server': [...], 'server-group': [...]}
@@ -193,7 +192,7 @@ define(
       // Tools menus
       tools: {},
       // Help menus
-      help: {}
+      help: {},
     },
     add_panels: function() {
       /* Add hooked-in panels by extensions */
@@ -209,8 +208,8 @@ define(
             showTitle: panel.showTitle,
             isCloseable: panel.isCloseable,
             isPrivate: panel.isPrivate,
-            url: panel.content
-          })
+            url: panel.content,
+          });
         } else {
           pgBrowser.panels[panel.name] = new pgBrowser.Panel({
             name: panel.name,
@@ -223,8 +222,8 @@ define(
             isPrivate: panel.isPrivate,
             content: (panel.content) ? panel.content : '',
             events: (panel.events) ? panel.events : '',
-            canHide: (panel.canHide) ? panel.canHide : ''
-          })
+            canHide: (panel.canHide) ? panel.canHide : '',
+          });
         }
       });
 
@@ -238,8 +237,8 @@ define(
         above: false,
         below: true,
         /* icon: 'fa fa-magic', */
-        single: true
-      }
+        single: true,
+      },
     },
     // A callback to load/fetch a script when a certain node is loaded
     register_script: function(n, m, p) {
@@ -251,37 +250,37 @@ define(
     buildDefaultLayout: function() {
       var browserPanel = this.docker.addPanel('browser', wcDocker.DOCK.LEFT);
       var dashboardPanel = this.docker.addPanel(
-              'dashboard', wcDocker.DOCK.RIGHT, browserPanel);
+        'dashboard', wcDocker.DOCK.RIGHT, browserPanel);
       this.docker.addPanel('properties', wcDocker.DOCK.STACKED, dashboardPanel, {
-          tabOrientation: wcDocker.TAB.TOP
+        tabOrientation: wcDocker.TAB.TOP,
       });
       this.docker.addPanel('sql', wcDocker.DOCK.STACKED, dashboardPanel);
       this.docker.addPanel(
-              'statistics', wcDocker.DOCK.STACKED, dashboardPanel);
+        'statistics', wcDocker.DOCK.STACKED, dashboardPanel);
       this.docker.addPanel(
-              'dependencies', wcDocker.DOCK.STACKED, dashboardPanel);
+        'dependencies', wcDocker.DOCK.STACKED, dashboardPanel);
       this.docker.addPanel(
-              'dependents', wcDocker.DOCK.STACKED, dashboardPanel);
+        'dependents', wcDocker.DOCK.STACKED, dashboardPanel);
     },
     // Enable/disable menu options
     enable_disable_menus: function(item) {
       // Mechanism to enable/disable menus depending on the condition.
-      var obj = this, j, e,
-          // menu navigation bar
-          navbar = $('#navbar-menu > ul').first(),
-          // Drop down menu for objects
-          $obj_mnu = navbar.find('li#mnu_obj > ul.dropdown-menu').first(),
-          // data for current selected object
-          d = obj.tree.itemData(item),
-          update_menuitem = function(m) {
-            if (m instanceof pgAdmin.Browser.MenuItem) {
-              m.update(d, item);
-            } else {
-              for (var key in m) {
-                update_menuitem(m[key]);
-              }
+      var obj = this,
+        // menu navigation bar
+        navbar = $('#navbar-menu > ul').first(),
+        // Drop down menu for objects
+        $obj_mnu = navbar.find('li#mnu_obj > ul.dropdown-menu').first(),
+        // data for current selected object
+        d = obj.tree.itemData(item),
+        update_menuitem = function(m) {
+          if (m instanceof pgAdmin.Browser.MenuItem) {
+            m.update(d, item);
+          } else {
+            for (var key in m) {
+              update_menuitem(m[key]);
             }
-          };
+          }
+        };
 
       // All menus from the object menus (except the create drop-down
       // menu) needs to be removed.
@@ -296,26 +295,22 @@ define(
         {m: 'management', id: '#mnu_management'},
         {m: 'tools', id: '#mnu_tools'},
         {m: 'help', id:'#mnu_help'}], function(o) {
-          _.each(
-            obj.menus[o.m],
-            function(m, k) {
-              update_menuitem(m);
-            });
-        });
+        _.each( obj.menus[o.m], function(m) { update_menuitem(m); });
+      });
 
       // Create the object menu dynamically
       if (item && obj.menus['object'] && obj.menus['object'][d._type]) {
         pgAdmin.Browser.MenuCreator(
           $obj_mnu, obj.menus['object'][d._type], obj.menu_categories, d, item
-        )
+        );
       } else {
         // Create a dummy 'no object seleted' menu
         var create_submenu = pgAdmin.Browser.MenuGroup(
           obj.menu_categories['create'], [{
-            $el: $('<li class="menu-item disabled"><a href="#">' + gettext("No object selected") + '</a></li>'),
+            $el: $('<li class="menu-item disabled"><a href="#">' + gettext('No object selected') + '</a></li>'),
             priority: 1,
             category: 'create',
-            update: function() {}
+            update: function() {},
           }], false);
         $obj_mnu.append(create_submenu.$el);
       }
@@ -323,11 +318,11 @@ define(
     save_current_layout: function(obj) {
       if(obj.docker) {
         var state = obj.docker.save();
-        var settings = { setting: "Browser/Layout", value: state };
+        var settings = { setting: 'Browser/Layout', value: state };
         $.ajax({
           type: 'POST',
           url: url_for('settings.store_bulk'),
-          data: settings
+          data: settings,
         });
       }
     },
@@ -344,11 +339,11 @@ define(
       // Initialize the Docker
       obj.docker = new wcDocker(
         '#dockerContainer', {
-        allowContextMenu: true,
-        allowCollapse: false,
-        themePath: '../static/css/',
-        theme: 'webcabin.overrides.css'
-      });
+          allowContextMenu: true,
+          allowCollapse: false,
+          themePath: '../static/css/',
+          theme: 'webcabin.overrides.css',
+        });
       if (obj.docker) {
         // Initialize all the panels
         _.each(obj.panels, function(panel, name) {
@@ -365,18 +360,18 @@ define(
         // Try to restore the layout if there is one
         if (layout != '') {
           try {
-            obj.docker.restore(layout)
+            obj.docker.restore(layout);
           }
           catch(err) {
             obj.docker.clear();
-            obj.buildDefaultLayout()
+            obj.buildDefaultLayout();
           }
         } else {
-          obj.buildDefaultLayout()
+          obj.buildDefaultLayout();
         }
 
         // Listen to panel attach/detach event so that last layout will be remembered
-        _.each(obj.panels, function(panel, name) {
+        _.each(obj.panels, function(panel) {
           if (panel.panel) {
             panel.panel.on(wcDocker.EVENT.ATTACHED, function() {
               obj.save_current_layout(obj);
@@ -393,16 +388,16 @@ define(
 
       // Syntax highlight the SQL Pane
       obj.editor = CodeMirror.fromTextArea(
-          document.getElementById("sql-textarea"), {
-            lineNumbers: true,
-            mode: "text/x-pgsql",
-            readOnly: true,
-            extraKeys: pgAdmin.Browser.editor_shortcut_keys,
-            tabSize: pgAdmin.Browser.editor_options.tabSize,
-            lineWrapping: pgAdmin.Browser.editor_options.wrapCode,
-            autoCloseBrackets: pgAdmin.Browser.editor_options.insert_pair_brackets,
-            matchBrackets: pgAdmin.Browser.editor_options.brace_matching
-          });
+        document.getElementById('sql-textarea'), {
+          lineNumbers: true,
+          mode: 'text/x-pgsql',
+          readOnly: true,
+          extraKeys: pgAdmin.Browser.editor_shortcut_keys,
+          tabSize: pgAdmin.Browser.editor_options.tabSize,
+          lineWrapping: pgAdmin.Browser.editor_options.wrapCode,
+          autoCloseBrackets: pgAdmin.Browser.editor_options.insert_pair_brackets,
+          matchBrackets: pgAdmin.Browser.editor_options.brace_matching,
+        });
 
       setTimeout(function() {
         obj.editor.refresh();
@@ -417,10 +412,10 @@ define(
         autoHide: false,
         build: function(element) {
           var item = obj.tree.itemFrom(element),
-              d = obj.tree.itemData(item),
-              menus = obj.menus['context'][d._type],
-              $div = $('<div></div>'),
-              context_menu = {};
+            d = obj.tree.itemData(item),
+            menus = obj.menus['context'][d._type],
+            $div = $('<div></div>'),
+            context_menu = {};
 
           pgAdmin.Browser.MenuCreator(
             $div, menus, obj.menu_categories, d, item, context_menu
@@ -428,72 +423,48 @@ define(
 
           return {
             autoHide: false,
-            items: context_menu
+            items: context_menu,
           };
-        }
+        },
       });
 
       // Treeview event handler
       $('#tree').on('acitree', function(event, api, item, eventName, options) {
         var d = item ? obj.tree.itemData(item) : null;
-
-        switch (eventName) {
-          // When a node is added in the browser tree, we need to
-          // load the registered scripts
-          case "added":
-            if (d) {
-              /* Loading all the scripts registered to be loaded on this node */
-              if (obj.scripts && obj.scripts[d._type]) {
-                var scripts = _.extend({}, obj.scripts[d._type]);
-
-                /*
-                 * We can remove it from the Browser.scripts object as
-                 * these're about to be loaded.
-                 *
-                 * This will make sure that we check for the script to be
-                 * loaded only once.
-                 *
-                 */
-                delete obj.scripts[d._type];
-              }
-            }
-            break;
-        }
-
         var node;
 
         if (d && obj.Nodes[d._type]) {
           node = obj.Nodes[d._type];
 
-          /* If the node specific callback returns false, we will also return
-           * false for further processing.
-           */
+            /* If the node specific callback returns false, we will also return
+             * false for further processing.
+             */
           if (_.isObject(node.callbacks) &&
-              eventName in node.callbacks &&
+            eventName in node.callbacks &&
               typeof node.callbacks[eventName] == 'function' &&
               !node.callbacks[eventName].apply(
-                  node, [item, d, obj, options, eventName])) {
+                node, [item, d, obj, options, eventName])) {
             return false;
           }
           /* Raise tree events for the nodes */
           try {
             node.trigger(
-                'browser-node.' + eventName, node, item, d
-                );
+              'browser-node.' + eventName, node, item, d
+            );
           } catch (e) {
-            console.log(e);
+            console.warn(e.stack || e);
           }
         }
 
         try {
           obj.Events.trigger(
-              'pgadmin-browser:tree', eventName, item, d
-              );
+            'pgadmin-browser:tree', eventName, item, d
+          );
           obj.Events.trigger(
-              'pgadmin-browser:tree:' + eventName, item, d, node
-              );
+            'pgadmin-browser:tree:' + eventName, item, d, node
+          );
         } catch (e) {
-          console.log(e);
+          console.warn(e.stack || e);
         }
         return true;
       });
@@ -508,9 +479,9 @@ define(
           url: url_for('misc.ping'),
           type:'POST',
           success: function() {},
-          error: function() {}
-          });
-        }, 300000);
+          error: function() {},
+        });
+      }, 300000);
       obj.Events.on('pgadmin:browser:tree:add', obj.onAddTreeNode, obj);
       obj.Events.on('pgadmin:browser:tree:update', obj.onUpdateTreeNode, obj);
       obj.Events.on('pgadmin:browser:tree:refresh', obj.onRefreshTreeNode, obj);
@@ -525,8 +496,8 @@ define(
         icon: icon,
         above: (above_separator === true),
         below: (below_separator === true),
-        single: single
-      }
+        single: single,
+      };
     },
 
     // This will hold preference data (Works as a cache object)
@@ -542,17 +513,17 @@ define(
         _.each(m.applies, function(a) {
           /* We do support menu type only from this list */
           if ($.inArray(a, [
-              'context', 'file', 'edit', 'object',
-              'management', 'tools', 'help']) >= 0) {
+            'context', 'file', 'edit', 'object',
+            'management', 'tools', 'help']) >= 0) {
             var menus;
 
-            // If current node is not visible in browser tree
-            // then return from here
+              // If current node is not visible in browser tree
+              // then return from here
             if(!checkNodeVisibility(self, m.node)) {
-                return;
+              return;
             } else if(_.has(m, 'module') && !_.isUndefined(m.module)) {
-              // If module to which this menu applies is not visible in
-              // browser tree then also we do not display menu
+                // If module to which this menu applies is not visible in
+                // browser tree then also we do not display menu
               if(!checkNodeVisibility(self, m.module.type)) {
                 return;
               }
@@ -575,17 +546,17 @@ define(
                 priority: m.priority, data: m.data, url: m.url,
                 target: m.target, icon: m.icon,
                 enable: (m.enable == '' ? true : (_.isString(m.enable) &&
-                   m.enable.toLowerCase() == 'false') ?
-                  false : m.enable),
-                node: m.node
+                    m.enable.toLowerCase() == 'false') ?
+                      false : m.enable),
+                node: m.node,
               });
             }
           } else  {
-            console && console.log &&
-              console.log(
-                  "Developer warning: Category '" +
+            console.warn(
+                'Developer warning: Category \'' +
                   a +
-                  "' is not supported!\nSupported categories are: context, file, edit, object, tools, management, help");
+                  '\' is not supported!\nSupported categories are: context, file, edit, object, tools, management, help'
+              );
           }
         });
       });
@@ -605,28 +576,28 @@ define(
         {menu: 'help', id:'#mnu_help'}],
         function(o) {
           var $mnu = navbar.children(o.id).first(),
-              $dropdown = $mnu.children('.dropdown-menu').first();
+            $dropdown = $mnu.children('.dropdown-menu').first();
           $dropdown.empty();
-          var menus = {};
 
           if (pgAdmin.Browser.MenuCreator(
             $dropdown, obj.menus[o.menu], obj.menu_categories
-            )) {
+          )) {
             $mnu.removeClass('hide');
           }
         });
 
       navbar.children('#mnu_obj').removeClass('hide');
-       obj.enable_disable_menus();
+      obj.enable_disable_menus();
     },
     // General function to handle callbacks for object or dialog help.
     showHelp: function(type, url, node, item, label) {
-      if (type == "object_help") {
+      var iframe, pnlProperties;
+      if (type == 'object_help') {
         // See if we can find an existing panel, if not, create one
         var pnlSqlHelp = this.docker.findPanels('pnl_sql_help')[0];
 
         if (pnlSqlHelp == null) {
-          var pnlProperties = this.docker.findPanels('properties')[0];
+          pnlProperties = this.docker.findPanels('properties')[0];
           this.docker.addPanel('pnl_sql_help', wcDocker.DOCK.STACKED, pnlProperties);
           pnlSqlHelp = this.docker.findPanels('pnl_sql_help')[0];
         }
@@ -641,30 +612,30 @@ define(
         var major = Math.floor(server.version / 10000),
           minor = Math.floor(server.version / 100) - (major * 100);
 
-        baseUrl = baseUrl.replace('$VERSION$', major + '.' + minor)
+        baseUrl = baseUrl.replace('$VERSION$', major + '.' + minor);
         if (!S(baseUrl).endsWith('/')) {
-          baseUrl = baseUrl + '/'
+          baseUrl = baseUrl + '/';
         }
         var fullUrl = baseUrl+ url;
         // Update the panel
-        var iframe = $(pnlSqlHelp).data('embeddedFrame');
+        iframe = $(pnlSqlHelp).data('embeddedFrame');
         pnlSqlHelp.title('Help: '+ label);
 
         pnlSqlHelp.focus();
         iframe.openURL(fullUrl);
-      } else if(type == "dialog_help") {
+      } else if(type == 'dialog_help') {
         if(this.docker) {
           // See if we can find an existing panel, if not, create one
           var pnlDialogHelp = this.docker.findPanels('pnl_online_help')[0];
 
           if (pnlDialogHelp == null) {
-            var pnlProperties = this.docker.findPanels('properties')[0];
+            pnlProperties = this.docker.findPanels('properties')[0];
             this.docker.addPanel('pnl_online_help', wcDocker.DOCK.STACKED, pnlProperties);
             pnlDialogHelp = this.docker.findPanels('pnl_online_help')[0];
           }
 
           // Update the panel
-          var iframe = $(pnlDialogHelp).data('embeddedFrame');
+          iframe = $(pnlDialogHelp).data('embeddedFrame');
 
           pnlDialogHelp.focus();
           iframe.openURL(url);
@@ -682,17 +653,20 @@ define(
       var self = this;
       // If cache is not yet loaded then keep checking
       if(_.size(self.preferences_cache) == 0) {
-        var preference_data = setInterval(check_preference, 1000);
-
-        function check_preference() {
-          if(_.size(self.preferences_cache) > 0) {
-            clearInterval(preference_data);
-            return _.findWhere(self.preferences_cache, {'module': module, 'name': preference});
-          }
-        }
+        var check_preference = function() {
+            if(_.size(self.preferences_cache) > 0) {
+              clearInterval(preferenceTimeout);
+              return _.findWhere(
+              self.preferences_cache, {'module': module, 'name': preference}
+            );
+            }
+          },
+          preferenceTimeout = setInterval(check_preference, 1000);
       }
       else {
-        return _.findWhere(self.preferences_cache, {'module': module, 'name': preference});
+        return _.findWhere(
+          self.preferences_cache, {'module': module, 'name': preference}
+        );
       }
     },
 
@@ -704,58 +678,57 @@ define(
         success: function(res) {
           self.preferences_cache = res;
         },
-        error: function(xhr, status, error) {
+        error: function(xhr) {
           try {
             var err = $.parseJSON(xhr.responseText);
             Alertify.alert(gettext('Preference loading failed.'),
               err.errormsg
             );
-          } catch (e) {}
-        }
+          } catch (e) { console.warn(e.stack || e); }
+        },
       });
     },
 
     _findTreeChildNode: function(_i, _d, _o) {
       var loaded = _o.t.wasLoad(_i),
-          done = true,
-          onLoad = function() {
-            var items = _o.t.children(_i),
-                i, d, n, idx = 0, size = items.length;
-            for (; idx < size; idx++) {
-              i = items.eq(idx);
-              d = _o.t.itemData(i);
-              if (d._type === _d._type) {
-                if (!_o.hasId || d._id == _d._id) {
-                  _o.i = i;
-                  _o.d = _d;
-                  _o.pI.push({coll: false, item: i, d: _d});
-
-                  _o.success();
-                  return;
-                }
-              } else {
-                n = _o.b.Nodes[d._type];
-                // Are we looking at the collection node for the given node?
-                if (
-                  n && n.collection_node && d.nodes &&
+        onLoad = function() {
+          var items = _o.t.children(_i),
+            i, d, n, idx = 0, size = items.length;
+          for (; idx < size; idx++) {
+            i = items.eq(idx);
+            d = _o.t.itemData(i);
+            if (d._type === _d._type) {
+              if (!_o.hasId || d._id == _d._id) {
+                _o.i = i;
+                _o.d = _d;
+                _o.pathOfTreeItems.push({coll: false, item: i, d: _d});
+
+                _o.success();
+                return;
+              }
+            } else {
+              n = _o.b.Nodes[d._type];
+              // Are we looking at the collection node for the given node?
+              if (
+                n && n.collection_node && d.nodes &&
                   _.indexOf(d.nodes, _d._type) != -1
-                ) {
-                  _o.i = i;
-                  _o.d = null;
-                  _o.pI.push({coll: true, item: i, d: d});
-
-                  // Set load to false when the current collection node's inode is false
-                  if (!_o.t.isInode(i)) {
-                    _o.load = false;
-                  }
-                  _o.b._findTreeChildNode(i, _d, _o);
-                  return;
+              ) {
+                _o.i = i;
+                _o.d = null;
+                _o.pathOfTreeItems.push({coll: true, item: i, d: d});
+
+                // Set load to false when the current collection node's inode is false
+                if (!_o.t.isInode(i)) {
+                  _o.load = false;
                 }
+                _o.b._findTreeChildNode(i, _d, _o);
+                return;
               }
             }
-            _o.notFound && typeof(_o.notFound) == 'function' &&
-              _o.notFound(_d);
-          };
+          }
+          _o.notFound && typeof(_o.notFound) == 'function' &&
+            _o.notFound(_d);
+        };
 
       if (!loaded && _o.load) {
         _o.t.open(_i, {
@@ -769,7 +742,7 @@ define(
             ) {
               fail.apply(_o.t, []);
             }
-          }
+          },
         });
       } else if (loaded) {
         onLoad();
